<style scoped>

    table td {
        text-align: center;
        vertical-align: middle;
    }

</style>

<template src="./showProductsComponent.htm"></template>

<script>

    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseOrderCartStoreObject());

            eventBus.$on('order-status-changed', (status) => this.orderStatusChanged(status));
        },

        data() {

            return {

                orderStatus: 0,

                final: 0,

                autocompleteKey: 0,

                total: 0,

                products: []
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * When order is loaded parse its products.
             */
            parseOrderCartStoreObject() {

                this.total = this.$store.state.finalOrder.cart.total;
                this.final = this.$store.state.finalOrder.final.final;

                let products = this.$store.state.finalOrder.cart.products;

                products.forEach((el) => {

                    this.products.push({

                        id: el.id,

                        product_id: el.product_id,

                        name: el.product_name,

                        image: el.product_main_image.src,

                        quantity: el.quantity,

                        price: el.price,

                        warehouses: el.product_variant.warehouse_inventories.map( (el) => {

                            return {

                                id: el.warehouse.id,
                                name: el.warehouse.name,
                                max: el.quantity
                            }
                        }),

                        warehouseId: null,

                        attributesValues: el.product_variant.product_attribute_values.map( (el) => {

                            return {

                                attribute: el.attribute.name,
                                value: el.attribute_value.value
                            }
                        })
                    });
                });
            },


            /**
             * Reset data if status is changed, because of fresh backend data.
             */
            orderStatusChanged(status) {

                this.orderStatus = status;
            },


            /**
             * Get small cached product image.
             *
             * @param src
             * @return {*}
             */
            getProductImage(src) {

                return route('images.cache', { template: 'small', filename: src });
            },


            /**
             * Create cart store object
             *
             * @param products
             */
            createFinalOrderProductsStoreObject(products) {

                return products.map( (el) => {

                    return {
                        id: el.id,
                        warehouse_id: el.warehouseId
                    }
                })
            }
        },

        watch: {

            /**
             * With each products change update in store.
             */
            products: {

                handler(newProducts) {

                    this.$store.dispatch('setFinalOrderCart', this.createFinalOrderProductsStoreObject(newProducts));
                },

                deep: true
            }
        }
    }

</script>